Download it now!
Bug 127142 - UI: Add 'Numbering Off' command to Format > Lists submenu
Summary: UI: Add 'Numbering Off' command to Format > Lists submenu
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
6.3.0.4 release
Hardware: All All
: medium enhancement
Assignee: Ayhan Yalçınsoy
URL:
Whiteboard: target:7.0.0
Keywords:
Depends on:
Blocks: Main-Menu
  Show dependency treegraph
 
Reported: 2019-08-24 20:53 UTC by Thomas Lendo
Modified: 2020-03-19 15:19 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Thomas Lendo 2019-08-24 20:53:32 UTC
When writing a list in a Writer document, then the user can remove the list numbering/bullets with the context menu. But in the main menu in Format > Lists it's not possible yet.

Suggestion for the sake of completeness: Add 'Numbering Off' command to Format > Lists submenu as it also exists in the list context menu.
Comment 1 Dieter 2019-08-25 08:22:00 UTC
More general

"Format => Lists" and "Bullets and numbering" in the context menu should be the same

Differences:
Numbering off in context menu, but not in Format => List (see comment 0)
different names: "Bullet list" ans "number list" in context menu; "bulleted list" and "numbered list" in Format => list
in Format => List you can remove list, if you click on marked "Bulleted List"; in context menue this is not possible
Comment 2 Thomas Lendo 2019-08-25 11:14:00 UTC
(In reply to Dieter Praas from comment #1)
> in Format => List you can remove list, if you click on marked "Bulleted
> List"; in context menue this is not possible
Ah, then this is the reason for the unavailability of this command. I haven't seen this. But anyway, I still vote for adding the command.
Comment 3 Dieter 2019-08-25 20:26:50 UTC
(In reply to Thomas Lendo from comment #2)
> But anyway, I still vote for adding the command.

Or, we delete the command in context menu and give possibility to remove list in the same way like in main menu

cc: Design Team for further input
Comment 4 Heiko Tietze 2019-08-26 06:54:19 UTC
AFAIK, "Numbering Off" is a different command than the numbering styles but would be required to toggle on/off with those. Not an easy hack, right Maxim?

And for the question whether to show or not, I vote for having it at both places. Actually the current radio buttons list of styles has none activated, which is wrong usability wise.
Comment 5 Maxim Monastirsky 2019-08-26 11:09:22 UTC
(In reply to Dieter Praas from comment #1)
There's some confusion here: The items in the context menu are applying styles (they correspond to the same items under the Styles menu), while the items in Format > List menu are about direct formatting (they correspond to the toolbar bullet and numbering toggle buttons). So:

> different names: "Bullet list" ans "number list" in context menu; "bulleted
> list" and "numbered list" in Format => list
Given that they're not the same, not necessarily they need to have same names.

> in Format => List you can remove list, if you click on marked "Bulleted
> List"; in context menue this is not possible
Right. "Bulleted List" in Format > List is about direct formatting, which you can toggle on and off, like any other direct formatting (e.g. Bold). While the context menu items are actually styles, and it doesn't make sense to "toggle" styles.
Comment 6 Dieter 2019-08-26 11:19:49 UTC
(In reply to Maxim Monastirsky from comment #5)
> (In reply to Dieter Praas from comment #1)
> There's some confusion here: The items in the context menu are applying
> styles (they correspond to the same items under the Styles menu), while the
> items in Format > List menu are about direct formatting

Thanks for clarification, but can a new user (or also en exeprienced user) be aware of that: There is no hint, that context menu affects styles:
- context menu => bullets and numbering => bullets and numbering doesn't open list style dialog (the dialog is "Bullets and Numbering"). According to your comment, this is a bug?
- with the other option you change the style, but doesn't modify it

In summary: Yes, confusing.
Comment 7 Maxim Monastirsky 2019-08-26 11:26:46 UTC
(In reply to Heiko Tietze from comment #4)
> AFAIK, "Numbering Off" is a different command than the numbering styles but
> would be required to toggle on/off with those.
It doesn't need to interact with the other commands, just to provide an on/off state on its own (which then can be visually represented as a radio button).

> Actually the current radio buttons list of styles has none
> activated, which is wrong usability wise.
True, but just want to point out that as long as this sub menu is static, it won't be possible to fully solve this problem by just providing the "Numbering Off" item. Because not all styles are listed there, and users can create their own styles. So again there is a possibility for the "none activated" state.
Comment 8 Maxim Monastirsky 2019-08-26 11:31:14 UTC
(In reply to Dieter Praas from comment #6)
> Thanks for clarification, but can a new user (or also en exeprienced user)
> be aware of that: There is no hint, that context menu affects styles:
> - context menu => bullets and numbering => bullets and numbering doesn't
> open list style dialog (the dialog is "Bullets and Numbering").
There is a similar situation with the Character and Paragraph sub menus of the context menu: Single direct formatting item on the top, followed by style commands. Confusing indeed.
Comment 9 Heiko Tietze 2019-08-26 12:20:13 UTC
(In reply to Maxim Monastirsky from comment #7)
> Because not all styles are listed there, and users can
> create their own styles. So again there is a possibility for the "none
> activated" state.

How about listing this particular user style, if active, among the preselection plus Off?
Comment 10 Maxim Monastirsky 2019-08-26 12:51:53 UTC
(In reply to Heiko Tietze from comment #9)
> How about listing this particular user style, if active, among the
> preselection plus Off?
That's likely the solution, but my point was that it isn't possible to do as long as it's a static menu (i.e. fully defined in xml). For this we'll need a dynamic menu which we can change at runtime (much like File > Recent Documents, or View > Toolbars), to add/remove the user style.
Comment 11 Heiko Tietze 2019-08-27 07:07:14 UTC
(In reply to Maxim Monastirsky from comment #10)
> For this we'll need a dynamic menu which we can change at runtime...

Sure, the static XML based menu is extended dynamically. Is that too difficult to realize? I imagine something like .uno:UserListStyle hidden when not active.
Comment 12 andreas_k 2019-08-27 08:21:28 UTC
dynamic styles support would be also very very usefull for draw/impress for shape styles. so in general it would be really cool.

from my point of view styles and direct formating is always confusing users, but that's the same in mso.
Comment 13 Thomas Lendo 2019-08-27 10:26:18 UTC
(In reply to Maxim Monastirsky from comment #5)
> Right. "Bulleted List" in Format > List is about direct formatting, which
> you can toggle on and off, like any other direct formatting (e.g. Bold).
> While the context menu items are actually styles, and it doesn't make sense
> to "toggle" styles.
Would it be too controversial to exchange the DF commands in the main menu to styles commands like in the context menu? What were the disadvantages for users?
Comment 14 Maxim Monastirsky 2019-08-27 10:47:48 UTC
(In reply to Heiko Tietze from comment #11)
> Sure, the static XML based menu is extended dynamically. Is that too
> difficult to realize?
It's doable. Two examples that come to my mind are the Window menu, which is defined in menubar.xml, but has the active windows list appended to its bottom, and the OLE object context menu, which has OLE verbs (e.g. Edit, Open) appended to its bottom. But with this kind of solution you don't really need a special .uno:UserListStyle command, as you operate directly on the menu, so you can just add/remove ordinary style commands.

> I imagine something like .uno:UserListStyle hidden when not active.
That's another possible solution, which can be done with a fully static menu too. Think of the "Record Macro" command, which defined in menubar.xml, but is hidden depending on the respective setting under Tools > Options... > LibreOffice > Advanced. But for such solution to work, we still need to retrieve the contents of the menu, and check whether the current style is actually one of the static items (doable via the XUIConfigurationManager interface). In addition, we'll need to set listeners (via XUIConfiguration), to make sure we don't miss user customization of the menu, and also make the status type of .uno:UserListStyle to be a string, so it changes its title depending on the style name.
Comment 15 Maxim Monastirsky 2019-08-27 10:54:23 UTC
(In reply to Thomas Lendo from comment #13)
> Would it be too controversial to exchange the DF commands in the main menu
> to styles commands like in the context menu?
Note that the list style commands already present in the main menu under Styles, and that most of the Format menu (esp. of its top part) is about DF anyway. Look at Text, Spacing, Align etc. sub menus - it's all about DF there.
Comment 16 Thomas Lendo 2019-08-27 11:34:04 UTC
(In reply to Maxim Monastirsky from comment #15)
You're right. Duplicating style commands is not a good solution. Maybe we need a better general approach to make more clear/visible what's DF and what's styles formatting. (Also for advanced users I assume that's not abvious.
Comment 17 Heiko Tietze 2019-08-27 13:08:46 UTC
(In reply to Maxim Monastirsky from comment #14)
> It's doable.

So let's do it. Removing needsUX flag.
Comment 18 Heiko Tietze 2020-02-17 13:35:36 UTC
Seems it was easier than expected. The Numbering Off command removes both the style as well the DF formatted lists.
Comment 19 Commit Notification 2020-02-17 13:35:48 UTC
ayhanyalcinsoy committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/73c69c96e3b582858cff5527fdd43157cffc5600

tdf#127142:UI: Add 'Numbering Off' command to Format > Lists submenu

It will be available in 7.0.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 20 Dieter 2020-03-19 15:19:50 UTC
(In reply to Commit Notification from comment #19)
> tdf#127142:UI: Add 'Numbering Off' command to Format > Lists submenu
> Affected users are encouraged to test the fix and report feedback.

Verified with

Version: 7.0.0.0.alpha0+ (x64)
Build ID: 5dcbd1bb557450a2d658a710c163b310c0cee157
CPU threads: 4; OS: Windows 10.0 Build 18363; UI render: Skia/Raster; VCL: win; 
Locale: de-DE (de_DE); UI-Language: en-GB
Calc: CL